'www.PredictiveEngineering.com
'All Rights Reserved, 2013
'Predictive Engineering Assumes No Responsibility For Results Obtained From API
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'This API was originally coded for FEMAP v10.02
'Updated for v12, Oct2018
'Written by Adrian Jensen
'Flips the view between Free Edge w/ black background and Quick Hidden Line w/ my color scheme

Sub Main

Dim App As femap.model
Set App = feFemap()

Dim feView As femap.View
Set feView = App.feView

Dim viewID As Long

rc = App.feAppGetActiveView( viewID )
rc = feView.Get( viewID )


If feView.WindowBackColor = 0 Then                'if the background color is black
	feView.Mode = FVM_HIDE                               'switch to Hidden Line Model Style
'Background
	feView.WindowBackColor = 86	                       'set upper background color to blue
	feView.WindowBackColor2 = 147                   'set lower background color to gray
	feView.WindowShadeBack = 1                        'set the background to a shaded style
'Label Parameters
	feView.ColorMode(0) = 1                                 'set Label Parameters to use View Color
	feView.color(0) = 0                                           'set Label Parameter color to black
'Feature Line
	feView.Draw(118)=1                                          'turn on Feature Line
	feView.Label(118) = 3                                        'Drawn Elements, Silhouette
	feView.ColorMode(118)=0	                                'no surface divisions
	feView.color(118)=27392                                  'set Feature Line color to black
	'feView.value1(118) = 30                                    'set Feature Line angle to 30 degrees
'View Legend
	feView.color(31) = 0                                           'set View Legend text color to black
'Post Titles
	feView.color(40) = 0                                            'set Post Titles text color to black
'Origin
	feView.Draw(33) = 1                                            'turn on the Origin symbol


ElseIf feView.WindowBackColor = 86 Then     'if the background color is blue
	feView.Mode = FVM_HIDE                            'switch to Hidden Line Model Style
'Background
	feView.WindowBackColor = 124                  'set upper background color to white
	feView.WindowBackColor2 = 147                'set lower background color to gray
	feView.WindowShadeBack = 0                     'set the background to a solid style
'Label Parameters
	feView.ColorMode(0) = 3                              'set Label Parameters to use View Color, Erase Back
	feView.color(0) = 0                                         'set Label Parameter color to black
'Feature Line
	feView.Draw(118)=1                                       'turn on Feature Line
	feView.Label(118) = 3                                     'Drawn Elements, Silhouette
	feView.ColorMode(118)=0                             'no surface divisions
	feView.color(118)=27392                                'set Feature Line color to black
	'feView.value1(118) = 30                                'set Feature Line angle to 30 degrees
'View Legend
	feView.color(31) = 0                                       'set View Legend text color to black
'Post Titles
	feView.color(40) = 0                                        'set Post Titles text color to black
'Origin
	feView.Draw(33) = 1                                       'turn on the Origin symbol


ElseIf feView.WindowBackColor = 124 Then   'if the background color is blue
	feView.Mode = FVM_HIDE                             'switch to Hidden Line Model Style
'Background
	feView.WindowBackColor = 174                  'set upper background color to white
	feView.WindowBackColor2 = 147                'set lower background color to gray
	feView.WindowShadeBack = 0                     'set the background to a solid style
'Label Parameters
	feView.ColorMode(0) = 3                               'set Label Parameters to use View Color, Erase Back
	feView.color(0) = 0                                          'set Label Parameter color to black
'Feature Line
	feView.Draw(118)=0                                        'turn off Feature Line
'View Legend
	feView.color(31) = 0                                        'set View Legend text color to black
'Post Titles
	feView.color(40) = 0                                        'set Post Titles text color to black
'Origin
	feView.Draw(33) = 1                                        'turn on the Origin symbol


Else
	feView.Mode = FVM_FREE                              'switch to Free Edge Model Style
'Background
	feView.WindowBackColor = 0                        'set upper background color to black
	feView.WindowBackColor2 = 147                  'set lower background color to gray
	feView.WindowShadeBack = 0                      'set the background to a solid style
'Label Parameters
	feView.ColorMode(0) = 1                                 'set Label Parameters to use View Color
	feView.color(0) = 124                                        'set Label Parameter color to white
'Feature Line
	feView.Draw(118)=0                                          'turn off Feature Line
'View Legend
	feView.color(31) = 124                                      'set View Legend text color to black
'Post Titles
	feView.color(40) = 124                                      'set Post Titles text color to black
'Origin
	feView.Draw(33) = 0                                          'turn off the Origin symbol
'Free Edge
	feView.ColorMode(22)=0                                 'set Free Edge view to use entity colors


End If

rc = feView.Put(viewID)
rc = App.feViewRegenerate(0)

End Sub
